package gui;

import common.CommonVariables;
import communication.ReadWrite;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;

/**
 *
 * @author sumanta
 */
public class BlueCanvas extends Canvas {

    private int height;
    private int width;
    private int x,  y;
    private boolean isCross = false,  isCircle = false;
    private BlueMIDlet parent;

    public BlueCanvas(BlueMIDlet parent) {
        this.parent = parent;
        height = getHeight();
        width = getWidth();
        x = y = 0;
        if (CommonVariables.myName.equals("server")) {
            isCross = true;
        } else {
            isCircle = true;
        }
    }

    protected void paint(Graphics g) {
        g.setGrayScale(255);
        g.fillRect(0, 0, width - 1, height - 1);
        g.setGrayScale(0);
        g.drawRect(0, 0, width - 1, height - 1);

        //indicator of turn, black or ash
        if (!CommonVariables.myTurn) {
            g.setGrayScale(150);
        }

        g.drawLine(width / 3, 0, width / 3, height);
        g.drawLine(2 * width / 3, 0, 2 * width / 3, height);
        g.drawLine(0, height / 3, width, height / 3);
        g.drawLine(0, 2 * height / 3, width, 2 * height / 3);

        char[][] board = CommonVariables.engine.getBoard();

        x = 0;
        y = 0;
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[i].length; j++) {


                if (board[i][j] == 'X') {
                    x = j * (width / 3);
                    y = i * (height / 3);
                    g.setColor(0, 0, 255);
                    g.drawLine(x, y, x + width / 3, y + height / 3);
                    g.drawLine(x + width / 3, y, x, y + height / 3);
                } else if (board[i][j] == 'O') {
                    x = j * (width / 3);
                    y = i * (height / 3);
                    g.setColor(255, 0, 0);
                    g.translate(x + width / 6, y + height / 6);
                    int k = Math.min(height / 3, width / 3) / 2;
                    g.drawArc(-k / 2, -k / 2, k, k, 0, 360);
                    g.translate(-(x + width / 6), -(y + height / 6));
                }

            }
        }


//        for (int i = 0; i < board.length; i++) {
//            for (int j = 0; j < board[i].length; j++) {
//                if (board[i][j] == 'O') {       
//                    x = i * width / 3;
//                    y = j * height / 3;
//                }
//                g.translate(x + width / 6, y + height / 6);
//                int k = Math.min(height / 3, width / 3) / 2;
//                g.drawArc(-k / 2, -k / 2, k, k, 0, 360);
//            }
//        }

    }

    protected void keyPressed(int key) {
        if (CommonVariables.myTurn) {
            String sendText = new String((key - 48) + "");
            if (CommonVariables.conn != null) {

                //just checkin
                boolean valid = CommonVariables.engine.setMove(Integer.parseInt(sendText), true);
                if (!valid) {
                    parent.switchDisplayable(new Alert("Error", "Invalid Move!", null, AlertType.ERROR),
                            this);
                    return;
                }
                //valid move, so send it to the opponent
                ReadWrite.write(sendText);
                CommonVariables.myTurn = false;

                boolean result = CommonVariables.engine.computeResult();
                if (result) {
                    parent.switchDisplayable(new Alert("You won!!"), parent.getTxtConnection());
                    ReadWrite.write("win");
                }

            } else {
                System.out.println("Connection element null while sending data");
            }
        } else {
            parent.switchDisplayable(parent.getTurnAlert(), this);
        }

        //drawShape(key);
        repaint();
    }

//    private void drawShape(int key) {
//        int position = key - 48;  //original number pressed
//
//        //each shape will be height/3 high and width/3 wide
//
//        if (position % 3 == 1) {
//            x = 0;
//        } else if (position % 3 == 2) {
//            x = width / 3;
//        } else if (position % 3 == 0) {
//            x = 2 * width / 3;
//        }
//        --position;
//        if (position / 3 == 0) {
//            y = 0;
//        } else if (position / 3 == 1) {
//            y = height / 3;
//        } else if (position / 3 == 2) {
//            y = 2 * height / 3;
//        }
//        isCircle = true;
//    //System.out.println("X: "+x+" Y: "+y);
//    }
}
